<object name="mp3_player">
  <window title="Freaky-Coo-MP3" name="mp3_player"
          ondelete="close_down"
          height="570" width="650">
    <frame visible="false" title="Play Queue">
      <clist name="playqueue" cols="3" onselect="set_selection"
             expand="true" height="180" ondrop="add_to_queue">
        <cl-title>
          <string name="song" text="Filename                                                                                         "/>
          <string name="length" text="Length"/>
          <string name="bitrate" text="Bitrate"/>
        </cl-title>
      </clist>
    </frame>

    <frame title="Database">
      <entry name="search_path" text="/home/john/music"/>
      <halign>
        <button onclick="rebuild_db" label="Rebuild the database"/>
        <button onclick="append_db" label="Append to database"/>
        <button onclick="stop" label="Stop mpg123"/>
      </halign>
    </frame>

    <frame title="Search">
      <entry name="search" text="" onenter="find_songs"/>
    </frame>

    <frame expand="true" title="Results">
      <scrollwindow expand="true">
        <clist name="mp3s" cols="1" onselect="play_song" 
               expand="true">
          <cl-title>
            <string name="title" text="Filename"/>
          </cl-title>
        </clist>
      </scrollwindow>
    </frame>
  </window>
  <data name="appenders" />
  <io name="rebuild" mode="line" onnewdata="append_to_db" />
  <perl><![CDATA[

use Symbol;
%ENV;
$HOME = $ENV{HOME};
$table_file = "$HOME/.mp3list";  # Where the list goes.
load_db();

sub load_db
{
	open TABLE_FILE, "<$table_file";
	@mp3s = <TABLE_FILE>;
}

sub append_to_db
{
	my ($io, $data, $size) = @_;   # $data is a line (mp3)
	if (0 == $size)
	{
		print "closing time\n";
		close ( $io->attrib("fh") );
		$io->attrib("fd" => "-1");

		if ($io->attrib_is_true ("rebuild") )
		{
			enode ("button.rebuild")->attrib ("sensitive" => "true");
		}
		$io->delete();
		my $object = enode("object.mp3_player");
		$object->new_child("io.rebuild",
		                   "mode" => "line",
		                   "onnewdata" => "append_to_db");
		return;
	}
	
	push @mp3s, $data;
	print TABLE_FILE $data;
}

sub rebuild_db
{
	my $rebuild_button = shift;

	my $io = enode("io.rebuild");
	my $fh = FH.$io;
	my $entry = enode("entry.search_path");
	my $search_path = $entry->attrib("text");

	# The SLOW_IS_A_GOOBER factor.
	# $rebuild_button->attrib ("sensitive" => "false");

	enode ("data.appenders")->delete_children ();

	close TABLE_FILE;
	unlink($table_file);                # Delete the file.
	open TABLE_FILE, ">$table_file";

	@mp3s = ();                          # DB gone too.

	open ($fh, "find $search_path -name '*.mp3*'|");
	$io->attrib("fd" => fileno($fh), "fh" => $fh, "rebuild" => "true");
}

sub append_db
{
	my $io_holder = enode("data.appenders");
	my $io = $io_holder->new_child ("io",
	                                "mode" => "line",
	                                "onnewdata" => "append_to_db");

	my $fh = FH.$io;
	my $entry = enode("entry.search_path");
	my $search_path = $entry->attrib("text");
	
	open ($fh, "find $search_path -name '*.mp3*'|");
	$io->attrib("fd" => fileno($fh), "fh" => $fh);
}

sub find_songs
{
	my $entry = shift;
	my $request = $entry->attrib("text");
	my $clist = enode("clist.mp3s");
	$clist->delete_children();

	#print "starting search for --$request--\n";
	foreach my $mp3 (@mp3s)
	{
		if($mp3 =~ /$request/)   ###    && $mp3 !~ /\&|\'/)
		{
			print "$mp3 matches\n";

			my $cl_row = $clist->new_child("cl-row");
			my $string = $cl_row->new_child("string.mp3",
			                                "text" => "$mp3",
			                                "dragdata-text" => "$mp3");
			print "$string\n";
			$string->attrib("text" => "$mp3");
			$string->attrib("dragdata-text" => "$mp3");
		}
	}
}
my $mpg123_PID;
sub play_song
{
	my $cl_row = shift;
	my $string_node = $cl_row->child("string.mp3");
	my $filename = $string_node->attrib("text");

	if ($mpg123_PID)
	{
		kill (9, $mpg123_PID);
	}
	close (MP3);
	chop $filename;
	$filename = qq!"!.$filename.qq!"\n!;  #put ""s and newline
	print "mpg123 $filename";
	$mpg123_PID = open (MP3, "|mpg123 -b 512 $filename");
}
sub add_to_queue
{
	print join(", ", @_), "\n";
}
sub stop
{
	if($mpg123_PID)
	{
		kill (9, $mpg123_PID);
	}
	close (MP3);
}

sub close_down
{
	if($mpg123_PID)
	{
		kill (9, $mpg123_PID);
	}
	close (MP3);
	exit();
}
  ]]></perl>
</object>
