#!/usr/bin/env entity
<!--
    FILE: "/home/joze/pub/entity/entity/apps/tagrefgen.e"
    LAST MODIFICATION: "Sun, 14 May 2000 17:41:53 +0200 (joze)"
    (C) 2000 by Johannes Zellner, <johannes@zellner.org>
    $Id: tagrefgen.e,v 1.2 2000/05/15 22:53:51 joze Exp $
 -->

<object default-lang = "tcl">
  <?tcl

    set out [open [pwd]/gtk-tag-reference.html w]
    set subcmds {attrib_value_type attrib_possible_values attrib_description}

    puts $out {
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<html>
  <head>
     <title>entity: gtk tag reference</title>
     <link rev=Made href="mailto:johannes@zellner.org">
     <link rel=Copyright href="<johannes@zellner.org>">
     <meta name="author" content="Johannes Zellner, <johannes@zellner.org>">
     <meta name="description" content="entity: gtk tag reference">
     <meta name="keywords" content="entity, gtk, tag, reference, perl, python, tcl">
     <style type="text/css">
      <!--
        body {
        /*
          display: block;
          background-color: white;
          font-family: Arial, Helvetica, sans-serif;
          border: none;
          border-width: 0;
          margin: 0;
          padding: 20pt 10% 0 10%;
          */
        }
        ul {
          list-style-type: none;
        }
        .table_caption {
          font: normal normal bold larger monospace;
          background-color: black;
          color: #d0d0ff;
          text-align: left;
          padding: 0 0 20 0;
        }
        .tag {
          font: normal normal bold large monospace;
          color: green;
          padding: 20 0 0 0;
          /* text-decoration: underline; */
        }
        .subcmds {
          font-weight: bold;
          background-color: #88ff88;
        }
        th.attrib {
          font: normal normal bold larger monospace;
          background-color: black;
          color: #d0d0ff;
          text-align: right;
          padding: 10 0 0 0;
        }
        div.table_div {
          text-align: center;
        }
        A.bigtags:link {
          color: #a0a0ff;
        }
        A.bigtags:active {
          color: red;
          font-size: 200%;
        }
        A.bigtags:visited {
          color: #a0a0ff;
        }
        .Arow {
          /* background-color: #88ff88; */
          background-color: #dddddd;
          margin: 0;
          border-width: 0;
        }
        .Brow {
          background-color: #ccccee;
          margin: 0;
          border-width: 0;
        }
        .A0 {
          font-weight: bold;
        }
        .B0 {
          font-weight: bold;
        }
        -->
     </style>
  </head>
  <body>
    }

    puts $out "<div class=table_div><table summary\"entity gtk tag reference\">"
    puts $out "  <tr><th colspan=4 class=table_caption>entity gtk tag reference</th></tr>"
    set obj [enode object]

    set tags {
      button
      checkbox
      cl-row
      clist
      dropdown
      ebox
      entry
      filesel
      fixed
      frame
      graph
      graph-point
      halign
      hpane
      hwrapalign
      image
      label
      list
      menu
      menubar
      menuitem
      notebook
      notepage
      object
      optionmenu
      progress
      radio
      radio-group
      scrollwin
      scrollwindow
      selection
      sh-cell
      sheet
      spinner
      text
      timer
      tr-item
      tree
      tree
      valign
      vpane
      vwrapalign
      window
    }

    puts $out "  <tr><td colspan=4>"
    # puts $out "    <ul>"
    set left " \["
    set right "\] "
    foreach tag $tags {
      # puts $out "      <li><a name=\"idx_$tag\" href=\"#$tag\">$tag</a></li>"
      puts $out "      $left<a name=\"idx_$tag\" href=\"#$tag\">$tag</a>$right"
    }
    # puts $out "    </ul>"
    puts $out "  </td></tr>"
    foreach tag $tags {
      set child       [$obj new_child $tag]
      set description [$obj description]
      set attribs     [lsort [$child  supported_attribs]]
      puts $out "  <tr><th colspan=4 class=attrib><a class=\"bigtags\" name=\"$tag\" href=\"#idx_$tag\">&lt;$tag&gt;</a>"
      if {"" != $description} {
        puts $out "  - $description"
      }
      puts $out "  </th></tr>"
      puts $out "  <tr><td></td>"
      foreach subcmd $subcmds {
        puts $out "  <td class=subcmds>$subcmd</td>"
      }
      puts $out "  </tr>"

      set leader A
      foreach attrib $attribs {
        puts $out "  <tr class=${leader}row>"
        set i 0
        puts $out "    <td class=${leader}0>$attrib</td>"
        foreach subcmd $subcmds {
          incr i
          puts $out "    <td>[$child $subcmd $attrib]</td>"
        }
        puts $out "  </tr>"
        if {"A" == $leader} {
          set leader B
        } else {
          set leader A
        }
      }

      $child delete
    }

    puts $out "</table></div>"

    puts $out "</body>"
    puts $out "</html>"
    close $out
    $obj entity:quit
  ?>
</object>


